﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.IdentityModel.Tokens;
using Senlan.VersionApp.Models;
using Senlan.VersionApp.Services.AppEditionService;
using System;
using System.IdentityModel.Tokens.Jwt;
using System.Security.Claims;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace Senlan.VersionApp.Controllers
{
    [Route("api/[controller]/[action]")]
    [ApiController]
    public class checkController : ControllerBase
    { 
         
        private readonly IAppEditionService appEditionService;
        public checkController(IAppEditionService appEditionService)
        { 
            this.appEditionService = appEditionService;
        }

        /// <summary>
        /// 获取App版本信息
        /// </summary>  
        /// <param name="appName">app名称</param> 
        /// <returns></returns>
        [HttpGet]
        public async Task<Result> GetAppVersionList(string? appName = "")
        {
            return await appEditionService.GetAppVersionList(appName);
        }

        /// <summary>
        /// 判断是否最新版本返回下载链接
        /// </summary>  
        /// <param name="name">唯一标识key</param>
        /// <param name="current_version">版本号</param>
        /// <returns></returns>
        [HttpGet]
        public async Task<Result> update(string name, string current_version)
        {
            return await appEditionService.UpdateAppVersion(name, current_version);
        }


    }
}
