﻿namespace Senlan.VersionApp.Models
{
    public class PagedArg
    {
        public int PageIndex { get; set; } = 1;
        public int PageSize { get; set; } = 8;

        public string Keyword { get; set; } = "";

        public DateTime DateBegin { get; set; }
        public DateTime DateEnd { get; set; }

        public int SkipCount
        {
            get { return (PageIndex - 1) * PageSize; }
        }
    }

    public class PagedArg<T> : PagedArg
    {
        public T Item1 { get; set; }
    }
    public class PagedArg<T1, T2> : PagedArg<T1>
    {
        public T2 Item2 { get; set; }
    }

    public class PagedArg<T1, T2, T3> : PagedArg<T1, T2>
    {
        public T3 Item3 { get; set; }
    }
}
