﻿using Microsoft.EntityFrameworkCore;
using Senlan.VersionApp.Data;
using Senlan.VersionApp.Entities;
using Senlan.VersionApp.Models;

namespace Senlan.VersionApp.Services.AppEditionService
{
    public class AppEditionService : BaseService<AppEdition>, IAppEditionService
    {
        public AppEditionService(SenlanDbContext db) : base(db)
        {
        }


        public async Task<Result> UpdateAppVersion(string appkey, string version)
        {
            var model = await db.AppEdition.Where(i => i.AppKey == appkey).FirstOrDefaultAsync();

            if (model == null)
            {
                return new Result("appkey输入错误");
            }
            else
            {
                if(model.Edition == version)  
                    return new Result(new { isflag = false, model.Download });
                else
                    return new Result(new { isflag = true ,model.Download });
            }

        }


        public async Task<Result> GetAppVersionList(string? appName)
        {
            var list = await (from a in db.AppEdition
                              where  (string.IsNullOrEmpty(appName) || a.AppName.Contains(appName))  
                              select a).ToListAsync(); 
            return new Result(list); 
        }
    }
}
