﻿using Senlan.VersionApp.Models;
using System.Linq.Expressions;

namespace Senlan.VersionApp.Services
{
    public interface IBaseService<T> where T : class
    {
        Task<T> Add(T entity);
        Task<bool> Add(List<T> entities);

        Task<bool> Delete(T entity);
        Task<bool> Delete(Guid id);
        Task<bool> Delete(Expression<Func<T, bool>> whereLambda);

        Task<bool> Update(T entity, List<string> updatePropertyList);
        Task<bool> Update(List<T> entitys);

        Task<bool> IsExist(Expression<Func<T, bool>> whereLambda);

        Task<T?> Get(Guid id);
        Task<T?> Get(Expression<Func<T, bool>> whereLambda);
        Task<List<T>> GetList(Expression<Func<T, bool>> whereLambda);

        Task<Tuple<List<T>, int>> GetPaged<S>(int pageSize, int pageIndex, Expression<Func<T, bool>> whereLambda, Expression<Func<T, S>> orderByLambda, bool isAsc);
    }
}
